library(Seurat)##version 4.0.5
library(dplyr)
library(future)
library(future.apply)

#library(DoubletFinder)
plan("multicore", workers = 6) ###compute cores
options(future.globals.maxSize = 150000 * 1024^2)
library(ggplot2)
library(scales)
library(gridExtra)
library(patchwork)
library(data.table)
library(Matrix)
library(ggsci)
library(harmony)
##define the color
??ggsci
#pal_npg()(11)
load("C:/Users/Zia20/OneDrive/01周志佳2023/02生信和基础文章/01前沿基因/00_scRNA_washdata.Rdata")
cors<-pal_igv()(34) 
Idents(sce.mergeTEN)=sce.mergeTEN@meta.data$RNA_snn_res.1
p1=DimPlot(sce.mergeTEN,reduction = "tsne",label = T,cols=cors,pt.size = 0.1) + NoLegend()
p2=DimPlot(sce.mergeTEN,reduction = "tsne",label = F,group.by = "orig.ident",cols=cors,pt.size = 0.1) 
Idents(sce.mergeTEN)=sce.mergeTEN@meta.data$seurat_clusters
p3=DimPlot(sce.mergeTEN,reduction = "tsne",label = F,cols=cors,pt.size = 0.1)
p4=DimPlot(sce.mergeTEN,reduction = "tsne",label = F,group.by = "site",cols=cors,pt.size = 0.1) 
p1+p2+p3+p4
ggsave("01_abcd_new.pdf",width =12,height = 9)
DotPlot(sce.mergeTEN,features = c("ALB","CYP3A5","CD14","FTL","FTH1","AOAH","MS4A6A","IL7R","CDH1","KRT7","VWF","PECAM1"),cols =cors[1:2])
ggsave("01_f_new.pdf",width =12,height = 4)

######热图和全部marker
sce.mergeTEN.markers <- FindAllMarkers(sce.mergeTEN, only.pos = TRUE, min.pct = 0.25, logfc.threshold = 0.25)
write.csv(sce.mergeTEN.markers,file="02_alvarez_allmarkers.csv")
top10 <-  sce.mergeTEN.markers %>% group_by(cluster) %>% top_n(n = 10, wt = avg_log2FC)
top3<-  sce.mergeTEN.markers %>% group_by(cluster) %>% top_n(n = 3, wt = avg_log2FC)
DotPlot(sce.mergeTEN,features = top3$gene)
DoHeatmap(sce.mergeTEN, features = top10$gene) + NoLegend()
DoHeatmap(sce.mergeTEN, features = top3$gene) + NoLegend()

###直接用singerR注释的结果
Idents(sce.mergeTEN)="inter_singleR"
# 查看每个cluster的marker基因数量
#table(markers$cluster)
DimPlot(sce.mergeTEN,reduction = "umap",cols=cors,label = T,label.size = 1.5)+NoLegend()
DimPlot(sce.mergeTEN,reduction = "umap",cols=cors,label = T,group.by = "site",label.size = 1.5)+NoLegend()
DimPlot(sce.mergeTEN,reduction = "umap",cols=cors,label = F,group.by = "site")
DimPlot(sce.mergeTEN,reduction = "umap",cols=cors,label = F,group.by = "etiology")
save(sce.mergeTEN,file = "02_chen_umap_singerR.Rdata")

##########AUC打分：
library(AUCell)
### AUCell评分并分配活性阈值
# 提取矩阵
exprMatrix <- sce.mergeTEN@assays$RNA@data
# 表达矩阵转rank矩阵
cells_rankings <- AUCell_buildRankings(exprMatrix)
#    min      1%      5%     10%     50%    100% 
# 212.00  341.00  458.85  554.00  819.00 2413.00
#以上数据意味着排名2413以后的基因没有价值
####导入基因集：
signatures=read.csv("in/glycosylation-related_genes.csv",header = F)

###########addmodule####################
signatures <- as.list(signatures)
sce <- AddModuleScore(sce.mergeTEN,features = signatures,name = 'glycosylation')
colnames(sce@meta.data)[16]="glycosylation_signature"
pdf(file="11_signature_umap.pdf", width = 5, height =4)
FeaturePlot(sce,features = c("glycosylation_signature"),reduction = "tsne",label = F,pt.size = 0.1,cols = c("#09070f","#b33651","#ecee8f"))+  
  theme(panel.border = element_rect(fill=NA,color="black", size=1, linetype="solid"))
ggsave(paste0("11_signature_umap",".tiff"),width = 5, height = 4)
dev.off()
sce@meta.data$Group=ifelse(sce@meta.data$glycosylation_signature>median(sce@meta.data$glycosylation_signature),"High_Gscore","Low_Gscore")
table(sce@meta.data$Group)
dev.off() 
DimPlot(sce,group.by = "Group",reduction = "tsne",label = F,pt.size = 0.1,cols = c("#09070f","#b33651"))+  
  theme(panel.border = element_rect(fill=NA,color="black", size=1, linetype="solid"))
ggsave(paste0("01e",".tiff"),width = 6, height = 4)


FeaturePlot(sce,features = c("glycosylation_signature"),split.by = "seurat_clusters",reduction = "tsne",label = F,pt.size = 0.1,cols = c("#09070f","#b33651","#ecee8f"))
ggsave(paste0("01gg",".tiff"),width = 20, height = 4)
#########找差异基因################################
Idents(sce)=sce@meta.data$Group
table(Idents(sce))
marker <- FindMarkers(sce, ident.1 = "High_Gscore",ident.2 = "Low_Gscore",only.pos = TRUE, min.pct = 0.25, logfc.threshold = 0.25)
marker2 <- FindMarkers(sce, ident.1 = "High_Gscore",ident.2 = "Low_Gscore",only.pos = F, min.pct = 0.1, logfc.threshold = 0.1)
marker3 <- FindMarkers(sce, ident.1 = "High_Gscore",ident.2 = "Low_Gscore",only.pos = F, min.pct = 0.25, logfc.threshold = 0.25)
marker4 <- FindMarkers(sce, ident.1 = "High_Gscore",ident.2 = "Low_Gscore",only.pos = F, min.pct = 0.25, logfc.threshold = 0.1)
#组间差异分


save(marker,file = "01_high_low_Gsore_diffgene.Rdata")
write.csv(marker,file = "01_diff_marker.csv")
write.csv(marker2,file = "01_diff_marker2.csv")
write.csv(marker3,file = "01_diff_marker3.csv")
write.csv(marker4,file = "01_diff_marker4.csv")
#####GSEA analysis####
library(devtools)
install_github("arc85/singleseqgset")##https://arc85.github.io/singleseqgset/articles/singleseqgset.html
#library(singleseqgset)
library(singleseqgset)
?msigdbr

h.human <- msigdbr(species="Homo sapiens",category="H")
h.names <- unique(h.human$gs_name)
h.sets <- vector("list",length=length(h.names))
h.names
names(h.sets) <- h.names
for (i in names(h.sets)) {
  h.sets[[i]] <- pull(h.human[h.human$gs_name==i,"gene_symbol"])
}

h.sets################hallmark的基因集



#expr.mat=sce.mergeTEN@assays$RNA@data




###内存小的话，跑小样本
expr.mat=sce@assays$RNA@data#[,c(1:1000)]###如果用全部细胞胞，则不要取前面1000个细胞
expr.mat[1:5,1:5]
sce@meta.data[1:5,]
group=sce$Group#[1:1000]##如果用全部细胞胞，则不要取前面1000个细胞

group
####计算每组相对于其他组的显著差异基因


logfc.data <- logFC(cluster.ids=sce$Group,expr.mat=expr.mat)


#logfc.data <- logFC(cluster.ids=sce.mergeTEN$Seurat_harmony[1:1000],expr.mat=expr.mat[,c(1:1000)])

names(logfc.data)
gse.res <- wmw_gsea(expr.mat=expr.mat,cluster.cells=logfc.data[[1]],log.fc.cluster=logfc.data[[2]],gene.sets=h.sets)

names(gse.res)
res.stats <- gse.res[["GSEA_statistics"]]
res.stats


ac<-data.frame(cluster=factor(colnames(res.stats)))
ac
rownames(ac)=colnames(res.stats)

ann_colors = list(
  cluster = c("Low_Gscore"="#5DB1DDFF", 
               "High_Gscore"="#D595A7FF" ))
  #GeneClass = c("CD4+" = "#7570B3", "CD8+" = "#E7298A","NK" = "#66A61E")
#)
library(stringr)
pdf(file="01H.pdf", width = 5, height =8)
rownames(res.stats)<-str_replace_all(rownames(res.stats),pattern = "HALLMARK_",replacement ="")
p1=pheatmap::pheatmap(res.stats,fontsize_row = 8,annotation_col = ac,annotation_legend = F,annotation_colors = ann_colors,cluster_rows = T,
                   cluster_cols = F,scale = "row")

dev.off()
p1
ggsave(p1,file="01_H.pdf")
############补充可视化的部分#######################
##########重新调整数据##################################
Idents(sce)
expr <- AverageExpression(sce, assays = "RNA", slot = "data")[[1]]
expr <- expr[rowSums(expr)>0,]  #过滤细胞表达量全为零的基因
expr <- as.matrix(expr)
head(expr)
head(sce)
##########
library(GSVA)
gsva.kegg <- gsva(expr, gset.idx.list = h.sets, 
                  kcdf="Gaussian",
                  method = "gsva",
                  parallel.sz=1)
head(gsva.kegg)
##############使用limma差异分析
library(limma)
# 构建分组文件
gsva.kegg=cbind(res.stats,res.stats)

group_list <- data.frame(celltype = colnames(gsva.kegg), group = c("High_Gscore","Low_Gscore"))

design <- model.matrix(~ 0 + factor(group_list$group))
colnames(design) <- levels(factor(group_list$group))
rownames(design) <- colnames(gsva.kegg)

# 构建差异比较矩阵
contrast.matrix <- makeContrasts(High_Gscore -Low_Gscore, levels = design)

# 差异分析，case vs. con
fit <- lmFit(gsva.kegg, design)
fit2 <- contrasts.fit(fit, contrast.matrix)
fit2 <- eBayes(fit2)
diff <- topTable(fit2, coef = 1, n = Inf, adjust.method = "BH", sort.by = "P")
head(diff)


#设置分组
diff$group <- ifelse( diff$logFC > 0 & diff$P.Value < 0.3 ,"up" ,
                      ifelse(diff$logFC < 0 & diff$P.Value < 0.3 ,"down","noSig")
)
diff$t=diff$logFC
library(tidyverse)
diff2 <- diff %>% 
  mutate(hjust2 = ifelse(t>0,1,0)) %>% 
  mutate(nudge_y = ifelse(t>0,-0.1,0.1)) %>% 
  #filter(group != "noSig") %>% #注释掉该行即可
  arrange(t) %>% 
  rownames_to_column("ID")


diff2$ID <- factor(diff2$ID, levels = diff2$ID)
limt = max(abs(diff2$t))

ggplot(diff2, aes(ID, t,fill=group)) + 
  geom_bar(stat = 'identity',alpha = 0.7) + 
  scale_fill_manual(breaks=c("down","up"), #设置颜色
                    values = c("#008020","#08519C"))+
  geom_text(data = diff2, aes(label = diff2$ID, #添加通路标签
                              y = diff2$nudge_y),
            nudge_x =0,nudge_y =0,hjust =diff2$hjust,
            size = 2)+ #设置字体大小
  labs(x = "", #设置标题 和 坐标
       y=paste0("LogFC of GSVA score\n","High_Gscore -Low_Gscore"),
       title = "GSVA")+
  scale_y_continuous(limits=c(-limt,limt))+
  coord_flip() + 
  theme_bw() + #去除背景色
  theme(panel.grid =element_blank(), #主题微调
        panel.border = element_rect(size = 0.6),
        plot.title = element_text(hjust = 0.5,size = 18),
        axis.text.y = element_blank(),
        axis.title = element_text(hjust = 0.5,size = 18),
        axis.line = element_blank(),
        axis.ticks.y = element_blank(),
        legend.position = "none" #去掉legend
  )
#dev.off()
ggsave("01_NEW_1F.pdf",width = 5,height = 7)
