#######scRNA######alvarez 3对3 癌旁
#######Alvarez######读入数据清洗###############
sc=readMM("../in/in_ Alvarez_snRNA_GSE189175/matrix.mtx.gz")
fc=fread("../in/in_ Alvarez_snRNA_GSE189175/features.tsv.gz",header = F)
bar=fread("../in/in_ Alvarez_snRNA_GSE189175/barcodes.tsv.gz",header = F)
for (i in 1:length(rownames(bar))) {
  bar$v3[i]=paste(bar$V1[i],bar$V2[i],sep ="_")
  print(i)
}

index=grep("NA",fc$V1)
sc=sc[-index,]
fc=fc[-index,]
colnames(sc)=bar$v3
rownames(sc)=fc$V2
which(rownames(sc)=="")
table(is.na(rownames(sc)))
index2=is.na(rownames(sc))
sc=sc[!index2,]
sc=sc[unique(rownames(sc)),]
Alvarez<-CreateSeuratObject(counts=sc,project = "Alvarez", min.cells = 3, min.features = 300)
VlnPlot(Alvarez, features = c("nFeature_RNA", "nCount_RNA"), ncol = 2)
Alvarez <- subset(Alvarez, subset = nFeature_RNA > 300 & nFeature_RNA < 2500 )
Alvarez[["paper"]] <- "Alvarez"
Alvarez@meta.data[1:10,]
remove(bar,fc,sc)
Alvarez@meta.data$patient=Alvarez@meta.data$orig.ident
Alvarez@meta.data$etiology="NASH"
S1=grep("S1",rownames(Alvarez@meta.data))
Alvarez@meta.data$etiology[S1]="NAFLD"
Alvarez@meta.data$site=ifelse(grepl("ant",rownames(Alvarez@meta.data)),"Normal","Tumor")
table(Alvarez@meta.data$site)
save(aizarani_healthy,file = "01_aizarani_healthy_raw.Rdata")
save(Alvarez,file = "01_Alvarez_raw.Rdata")

###############单细胞处理流程得到数据##############
####load package 
library(Seurat)##version 4.0.5
library(dplyr)
library(future)
library(future.apply)
library(DoubletFinder)
plan("multicore", workers = 6) ###compute cores
options(future.globals.maxSize = 150000 * 1024^2)
library(ggplot2)
library(scales)
library(gridExtra)
library(patchwork)
library(data.table)
library(Matrix)
library(ggsci)
library(harmony)
##define the color
??ggsci
#pal_npg()(11)
cors<-pal_igv()(34) 
sce.mergeTEN=Alvarez

sce.mergeTEN@meta.data[1:5,]
s.genes <- cc.genes$s.genes
g2m.genes <- cc.genes$g2m.genes  ###NETs相关的分数情况？？不一定能用
sce.mergeTEN <- CellCycleScoring(sce.mergeTEN, s.features = s.genes, g2m.features = g2m.genes, set.ident = TRUE)
sce.mergeTEN@meta.data[1:5,]
sce.mergeTEN[["percent.mt"]] <- PercentageFeatureSet(sce.mergeTEN, pattern = "^MT-")
sce.mergeTEN<-NormalizeData(sce.mergeTEN,verbose = T) 
sce.mergeTEN<-FindVariableFeatures(sce.mergeTEN,selection.method = "vst", nfeatures = 2000)
sce.mergeTEN<-ScaleData(sce.mergeTEN,vars.to.regress = c("percent.mt","S.Score","G2M.Score"),verbose = FALSE)
ElbowPlot(sce.mergeTEN,ndims = 100)
sce.mergeTEN<-RunPCA(sce.mergeTEN,verbose = T,npcs = 25)

p1 <- DimPlot(object = sce.mergeTEN, reduction = "pca", pt.size = .1, group.by = "orig.ident")
p2 <- VlnPlot(object = sce.mergeTEN, features = "PC_1", group.by = "orig.ident", pt.size = .1)
CombinePlots(plots=list(p1,p2))
sce.mergeTEN<-RunHarmony(sce.mergeTEN,group.by.vars = c("orig.ident"), plot_convergence = TRUE)
###也可以去掉其他的因素，技术，实验室的情况，多种情况才能合并
harmony_embeddings <- Embeddings(sce.mergeTEN, 'harmony')
dim(harmony_embeddings)
p3 <- DimPlot(object = sce.mergeTEN, reduction = "harmony", pt.size = .1, group.by = "orig.ident")
p4 <- VlnPlot(object = sce.mergeTEN, features = "harmony_1", group.by = "orig.ident", pt.size = .1)
CombinePlots(plots=list(p3,p4))

p1+p3

sce.mergeTEN <- sce.mergeTEN %>% 
  RunUMAP(reduction = "harmony", dims = 1:20) %>% 
  RunTSNE(reduction = "harmony", dims = 1:20) %>%
  FindNeighbors(reduction = "harmony", dims = 1:20)



sce.mergeTEN<-FindClusters(sce.mergeTEN,resolution = 1)

table(Idents(sce.mergeTEN))


#Idents(sce_inter)<-sce_inter$seurat_clusters
sce.mergeTEN@meta.data[1:5,]
p1<-DimPlot(sce.mergeTEN,reduction = "tsne",label = T)
p1
DimPlot(sce.mergeTEN,reduction = "umap",label = T)
DimPlot(sce.mergeTEN,reduction = "umap",label = T,cols=cors,pt.size = 0.2)# + NoLegend()
DimPlot(sce.mergeTEN,reduction = "tsne",label = T,cols=cors,pt.size = 0.1) + NoLegend()
#DimPlot(sce.mergeTEN,reduction = "umap",label = T,split.by = "tissue_type")
#table(sce.mergeTEN@meta.data$cell_cluster_origin)

sce.mergeTEN@meta.data[1:5,]
DimPlot(sce.mergeTEN,reduction = "tsne",label = F,group.by = "orig.ident",cols=cors,pt.size = 0.2)
#####用genome_med的marker
cmarker=read.csv("/Users/feng/OneDrive/01周志佳2023/02生信和基础文章/01前沿基因/cellmarker.csv",header = F)
Idents(sce.mergeTEN)=sce.mergeTEN@meta.data$RNA_snn_res.1
DotPlot(sce.mergeTEN,features = cmarker)
ggsave("dotmarker.pdf",width = 40,height = 20)
cmarker=strsplit(cmarker$V1," ")

cmarker=unlist(cmarker)

####自动注释
library(SingleR)
library(celldex)
sc_data<-as.matrix(sce.mergeTEN@assays$RNA@counts)
hpca.se <- HumanPrimaryCellAtlasData()
hpca.se$label.main

pred.hesc <- SingleR(test = sc_data, ref = hpca.se, assay.type.test=1,
                     labels = hpca.se$label.main)
#pred.hesc$labels###预测的结果
length(table(pred.hesc$labels))
sce.mergeTEN@meta.data$inter_singleR=pred.hesc$labels
#Idents(sce.mergeTEN)
ident=table(Idents(sce.mergeTEN),sce.mergeTEN@meta.data$inter_singleR)
ident=as.data.frame(ident)
write.csv(ident,file="02_alvarez_singerR.csv")
options(max.print=2000)

###hepatocyte
FeaturePlot(sce.mergeTEN,features = c("ALB","HNF4A","EPCAM","TF","TTR","CYP2A6"),reduction = "umap",label = T)

DotPlot(sce.mergeTEN,features = c("ALB","HNF4A","EPCAM","TF","TTR","CYP2A6"))


###epithelial cell
FeaturePlot(sce.mergeTEN,features = c("EPCAM","CDH1","KRT7","KRT5","UPK1A","KRT20"),reduction = "umap",label = T)

DotPlot(sce.mergeTEN,features = c("EPCAM","CDH1","KRT7","KRT5","UPK1A","KRT20"))
##TNK cell
FeaturePlot(sce.mergeTEN,features = c("CD3D","CD8A","CD4","NCAM1","IL7R"),reduction = "umap",label = T)
DotPlot(sce.mergeTEN,features = c("CD3D","CD8A","CD4","NCAM1","IL7R"))

##endothelial cell
FeaturePlot(sce.mergeTEN,features = c("VWF","PECAM1"),reduction = "tsne",label = T)
DotPlot(sce.mergeTEN,features = c("VWF","PECAM1"))
####fibroblasts and pericytes
FeaturePlot(sce.mergeTEN,features = c("RGS5","COL1A1","PDGFRA","PDGFRB","DES"),reduction = "umap",label = T)
DotPlot(sce.mergeTEN,features = c("RGS5","COL1A1","PDGFRA","PDGFRB","DES"))
###B cell and plasma 
FeaturePlot(sce.mergeTEN,features = c("CD19","JCHAIN","CD79A"),reduction = "umap",label = T)
DotPlot(sce.mergeTEN,features = c("CD19","JCHAIN","CD79A"))

###myeloid cell
FeaturePlot(sce.mergeTEN,features = c("CD74","CD14","FCGR3A","S100A8"),reduction = "umap",label = T)
DotPlot(sce.mergeTEN,features = c("CD74","CD14","FCGR3A","S100A8"))
###mast cell
FeaturePlot(sce.mergeTEN,features = c("CPA3"),reduction = "tsne",label = T)
DotPlot(sce.mergeTEN,features = c("CPA3"))


sce.mergeTEN<-RenameIdents(sce.mergeTEN,
                           "0"="Hepatocyte","3"="Hepatocyte","4"="Hepatocyte",
                           "5"="Hepatocyte","7"="Hepatocyte","12"="Hepatocyte","13"="Hepatocyte","15"="Hepatocyte",
                           "20"="Hepatocyte",
                           "22"="Myeloid cell","17"="Myeloid cell","9"="Myeloid cell","16"="Myeloid cell","18"="Myeloid cell",
                           "2"="Plasma cell","1"="Plasma cell",
                           "6"="T/NK","8"="T/NK","10"="T/NK","21"="T/NK",
                           "19"="Cholangiocyte","14"="Cholangiocyte",
                           "11"="Endothelial cell")

sce.mergeTEN@meta.data$seurat_clusters=Idents(sce.mergeTEN)
Idents(sce.mergeTEN)=sce.mergeTEN@meta.data$RNA_snn_res.1
save(sce.mergeTEN,file = "00_scRNA_washdata.Rdata")
