rm(list = ls())
options(stringsAsFactors = F)

## 加载R包
library(tibble)
library(dplyr)
library(tidyr)
library(ggpubr)


########读入数据
load("~/OneDrive/01周志佳2023/02生信和基础文章/01前沿基因/figure10/data/GSE48452/GSE48452.Rdata")
xixi=c("SPP1","SOCS2","SAPCD2","S100A9","RAMP3","CSAD")
trim <- function (x){
  gsub("^\\s+|\\s+$", "", x)
}

trim("   test  ") ##test
rownames(GSE48452_expr)=trim(rownames(GSE48452_expr))
intersect(xixi,rownames(GSE48452_expr))
save(GSE48452_expr,GSE48452_metadata,file = "GSE48452.Rdata")
expr=GSE48452_expr[intersect(xixi,rownames(GSE48452_expr)),]
expr=t(expr)
expr=expr[-74,]
str(expr)
y=apply(y,2,as.numeric)
expr=apply(expr,2,as.numeric)
rownames(GSE48452_metadata)=GSE48452_metadata[,1]
rownames(expr)==rownames(GSE48452_metadata)
dat=cbind(GSE48452_metadata,expr)
str(dat)
for (i in 1:5) {
############ 3.多组比较
## stat_compare_means()中可以指定比较哪些组
my_comparisons <- list(c("Control", "Nash"), c("Nash", "Healthy obese"), c("Nash", "Steatosis"))
ggboxplot(dat, x="group", y=colnames(dat)[i+13], color = "group",palette = "lancet")+
  # Add pairwise comparisons p-value 即是各组两两比较的P值，默认wilcox.test
  stat_compare_means(comparisons=my_comparisons,method = "t.test")#+ 
  # Add global p-value 即是全局比较，这里是3组比较的p值，默认Kruskal-Wallis
  #stat_compare_means() 
ggsave(paste0(colnames(dat)[i+13],"_expression.pdf"))
}
#########相关性热图################
#####去掉NA值############
library(tidyverse)
dat2=dat %>% 
  filter(lar!="NA")
dat2=dat2[,c(2,5,6,10,11,12,14,15,16,17,18)]
library(corrplot)
library(ggplot2)
library(ggpubr)
class(dat2)
str(dat2)
cor(dat2, method="pearson")
tdc <- cor (dat2, method="pearson")
corrplot(tdc)
corrplot(tdc, method = "ellipse", 
         type = "upper",
         tl.col = "black", tl.cex = 1.2, tl.srt = 45
)

addcol <- colorRampPalette(c("red", "white", "blue"))
testRes = cor.mtest(dat2, menthod = "pearson", conf.level = 0.95)
corrplot(tdc, method = "color", col = addcol(100), 
         tl.col = "black", tl.cex = 0.8, tl.srt = 45,tl.pos = "lt",
         p.mat = testRes$p, diag = T, type = 'upper',
         sig.level = c(0.001, 0.01, 0.05), pch.cex = 1.2,
         insig = 'label_sig', pch.col = 'grey20', order = 'AOE')
p2=corrplot(tdc, method = "number", type = "lower",col = addcol(100), 
         tl.col = "n", tl.cex = 0.8, tl.pos = "n",order = 'AOE',
         add = T)
ggsave("cor.pdf")


######
load("/Users/feng/OneDrive/01周志佳2023/02生信和基础文章/01前沿基因/figure10/data/GSE89632/GSE89632.Rdata")
setwd("~/OneDrive/01周志佳2023/02生信和基础文章/01前沿基因/figure10/plot")
expr=GSE89632_expr[intersect(xixi,rownames(GSE89632_expr)),]
expr=t(expr)
str(expr)
expr1=apply(expr,2,as.numeric)
rownames(expr1)=rownames(expr)
rownames(GSE89632_metadata)=GSE89632_metadata[,1]
rownames(expr)==rownames(GSE89632_metadata)
dat=cbind(GSE89632_metadata,expr1)
dir.create("GSE89632")
setwd("~/OneDrive/01周志佳2023/02生信和基础文章/01前沿基因/figure10/plot/GSE89632")
str(dat)
table(dat$group)
for (i in 1:5) {
  ############ 3.多组比较
  ## stat_compare_means()中可以指定比较哪些组
  my_comparisons <- list(c("HC", "NASH"), c("HC", "SS"), c("NASH", "SS"))
  ggboxplot(dat, x="group", y=colnames(dat)[i+27], color = "group",palette = "lancet")+
    # Add pairwise comparisons p-value 即是各组两两比较的P值，默认wilcox.test
    stat_compare_means(comparisons=my_comparisons,method = "t.test")+ 
  # Add global p-value 即是全局比较，这里是3组比较的p值，默认Kruskal-Wallis
  stat_compare_means() 
  ggsave(paste0(colnames(dat)[i+27],"_expression.pdf"))
}
#########相关性热图################
#####去掉NA值############
colnames(dat)
dat2=dat[,-c(1,2,9,10,14,19:23)]
dat2=na.omit(dat2) 
library(tidyverse)
dat2=dat %>% 
  filter(lar!="NA")
dat2=dat2[,c(2,5,6,10,11,12,14,15,16,17,18,19,20,21,22)]
library(corrplot)
library(ggplot2)
library(ggpubr)
class(dat2)
str(dat2)
write.csv(dat2,file = "xixi.csv")
dat2=read.csv("xixi.csv",row.names = 1)
cor(dat2, method="pearson")
tdc <- cor (dat2, method="pearson")
corrplot(tdc)
corrplot(tdc, method = "ellipse", 
         type = "upper",
         tl.col = "black", tl.cex = 1.2, tl.srt = 45
)

addcol <- colorRampPalette(c("red", "white", "blue"))
testRes = cor.mtest(dat2, menthod = "pearson", conf.level = 0.95)
corrplot(tdc, method = "color", col = addcol(100), 
         tl.col = "black", tl.cex = 0.8, tl.srt = 45,tl.pos = "lt",
         p.mat = testRes$p, diag = T, type = 'upper',
         sig.level = c(0.001, 0.01, 0.05), pch.cex = 1.2,
         insig = 'label_sig', pch.col = 'grey20', order = 'AOE')
corrplot(tdc, method = "number", type = "lower",col = addcol(100), 
            tl.col = "n", tl.cex = 0.8, tl.pos = "n",order = 'AOE',
            add = T)

###########PCR的结果##########
####
dat=read.csv("/Users/feng/OneDrive/01周志佳2023/02生信和基础文章/01前沿基因/figure10/pcr.csv")
dat=dat[,-8]
table(dat$group)
for (i in 2:7) {
  ############ 3.多组比较
  ## stat_compare_means()中可以指定比较哪些组
  my_comparisons <- list(c("NC", "NAFLD"))
  
  ggboxplot(dat, x="group", y=colnames(dat)[i], color = "group",palette = "lancet")+
    # Add pairwise comparisons p-value 即是各组两两比较的P值，默认wilcox.test
    stat_compare_means(comparisons=my_comparisons,method = "t.test")#+ 
    # Add global p-value 即是全局比较，这里是3组比较的p值，默认Kruskal-Wallis
    #stat_compare_means() 
  ggsave(paste0(colnames(dat)[i],"_expression.pdf"))
}


###########PCR############
# 导入所需的包
library(ggplot2)
library(ggsignif)
library(ggpubr)
library(ggsci)
library(tidyverse)

# 导入数据
dat=read.csv("/Users/feng/OneDrive/01周志佳2023/02生信和基础文章/01前沿基因/figure10/pcr.csv")
dat=dat[,-8]
plot_data=dat
group=levels(factor(plot_data$group))

plot_data$group=factor(plot_data$group, levels=c("NC","NAFLD"))
comp=combn(group,2)
my_comparisons=list()
for(i in 1:ncol(comp)){my_comparisons[[i]]<-comp[,i]}
#plot_data2 <- read.csv(file = "NPT.csv")
#plot_data=plot_data[1:60,]
td=list()
for (i in 2:7) {
  plot_data2=plot_data[,c(1,i)]
  colnames(plot_data2)=c("group","Retive_Abundance")
  na.omit(plot_data2)
  #########随机生成数字##############
  #plot_data2=data.frame(group=c(rep("con",9),rep("hcc",9),rep("gjf",9)),Retive_Abundance=runif(27,min=5,max=30))
  #plot_data2$group=factor(plot_data2$group, levels=c("con","hcc","gjf"))
  ######统计此行######使用一个包tidyverse
  
  by_group=group_by(plot_data2,group)
  plot_data1=summarise(by_group,count=n(),mean=mean(Retive_Abundance), sd=sd(Retive_Abundance))
  
  #设置比较组
  
  ######调整图中的分组顺序
  ####plot_data2$group=factor(plot_data2$group, levels=c("con","hcc","gjf"))#用来调整顺序
  
  
  #-----------------------
  p<- ggplot()+ 
    geom_bar(data=plot_data1,mapping=aes(x=group,y=mean), #柱状图
             fill = "white",
             size = 1,
             color = c("#1E90FF","red"),
             position="dodge", # 柱状图格式
             stat="identity", # 数据格式
             width = 0.6)+  # 柱状图尺寸
    geom_jitter(data=plot_data2, #散点
                mapping=aes(x=group,y=Retive_Abundance,fill = group,colour = group,shape = group),
                size = 1,
                height = 0.05,#散点纵向抖动
                
                width = 0.1)+ #散点横向抖动
    scale_color_manual(values = c("#1E90FF","red"))+ #散点颜色
    geom_signif(data=plot_data2,mapping=aes(x=group,y=Retive_Abundance), # 不同组别的显著性
                comparisons = my_comparisons,
                #annotation=c("**"), # 显著性差异做标记
                map_signif_level=F, # T为显著性，F为p value
                tip_length=c(0,0,0,0,0,0), # 修改显著性线两端的长短
                #y_position = c(46,54,49), # 设置显著性线的位置高度
                size=1, # 修改线的粗细
                textsize = 7, # 修改*标记的大小
                test = "t.test")+ # 检验的类型
    geom_errorbar(data=plot_data1,mapping=aes(x = group,ymin = mean-sd, ymax = mean+sd), # 误差线添加
                  width = 0.3, #误差线的宽度
                  color = c("#1E90FF","red"), #颜色
                  size=0.8)+ #粗细
    #scale_y_continuous(limits =c(0, 60) ,expand = c(0,0))+ # y轴的范围
    theme_classic(  # 主题设置，这个是无线条主题
      base_line_size = 0.5 # 坐标轴的粗细
    )+
    labs(title="",x="",y=paste0("Relative mRNA ",colnames(plot_data)[i]," level/β-actin"))
  #+ # 添加标题，x轴，y轴内容
  # theme(plot.title = element_text(size = 15,
  #                                 colour = "black",
  #                                 hjust = 0.5),
  #       axis.title.y = element_text(size = 15, 
  #                                   # family = "myFont", 
  #                                   color = "black",
  #                                   face = "bold", 
  #                                   vjust = 1.9, 
  #                                   hjust = 0.5, 
  #                                   angle = 90),
  #       legend.title = element_text(color="black", # 修改图例的标题
  #                                   size=15, 
  #                                   face="bold"),
  #       legend.text = element_text(color="black", # 设置图例标签文字
  #                                  size = 10, 
  #                                  face = "bold"),
  #       axis.text.x = element_text(size = 13,  # 修改X轴上字体大小，
  #                                  color = "black", # 颜色
  #                                  face = "bold", #  face取值：plain普通，bold加粗，italic斜体，bold.italic斜体加粗
  #                                  vjust = 0.5, # 位置
  #                                  hjust = 0.5, 
  #                                  angle = 0), #角度
  #       axis.text.y = element_text(size = 13,  
  #                                  color = "black",
  #                                  face = "bold", 
  #                                  vjust = 0.5, 
  #                                  hjust = 0.5, 
  #                                  angle = 0) 
  # 
  #      ) 
  ggsave(paste0(colnames(plot_data)[i],".pdf"),height = 7,width = 5)
#########加一个列表#################
  }
library(patchwork)
p
