##############ssGSEA###############
##########TCGA########TPM数据，log2转化#########
setwd("C:/Users/Zia20/OneDrive/01周志佳2023/02生信和基础文章/01前沿基因")
library(data.table)
load("C:/Users/Zia20/OneDrive/01周志佳2023/02生信和基础文章/01前沿基因/TCGA.Rdata")
tcga=fread("TCGA.TPM.txt")

tcga=as.data.frame(tcga)
rownames(tcga)=tcga[,1]
tcga=tcga[,-1]
bulk_dataset=as.matrix(tcga)
colnames(bulk_dataset)=substring(colnames(bulk_dataset),1,12)
rtt=bulk_dataset
exprSet=rtt[,intersect(rownames(cli),colnames(rtt))]

options("repos"=c(CRAN="https://mirrors.tuna.tsinghua.edu.cn/CRAN/"))
options(BioC_mirror="https://mirrors.tuna.tsinghua.edu.cn/bioconductor")
if(!require("data.table")) install.packages("data.table",update = F,ask = F)
if(!require("GSVA")) BiocManager::install("GSVA",update = F,ask = F)

### 直接讲解：ssGSEA
### 需要表达量数据和marker数据
### marker数据的获取
### Pan-cancer Immunogenomic Analyses Reveal Genotype-Immunophenotype Relationships and Predictors of Response to Checkpoint Blockade
### https://www.cell.com/cms/10.1016/j.celrep.2016.12.019/attachment/f353dac9-4bf5-4a52-bb9a-775e74d5e968/mmc3.xlsx
#rm(list = ls())
### 1.准备细胞marker
####导入基因集：
cellMarker=read.csv("in/glycosylation-related_genes.csv",header = F)
colnames(cellMarker)[1] <- "Glycosylation"
cellMarker <- as.list(cellMarker)
###########addmodule####################
expr <- as.matrix(exprSet)

### 3.使用ssGSEA量化免疫浸润
library(GSVA)
gsva_data <- gsva(expr,cellMarker, method = "ssgsea")
##########分组做生存分析######################
gsva_cosre=t(gsva_data)
gsva_cosre=as.data.frame(gsva_cosre)
gsva_cosre$Group=ifelse(gsva_cosre[,1]>median(gsva_cosre[,1]),"High_Gscore","Low_Gscore")
table(gsva_cosre$Group)
#######################################生存分析###################
library(survival)
library(survminer)
rownames(cli)==rownames(gsva_cosre)
tcga_sur=cbind(cli,gsva_cosre)
tcga_sur$futime=tcga_sur$futime/365
save(tcga_sur,file = "02_wgcna_clinc.Rdata")
# 1. Determine the optimal cutpoint of variables
res.cut <- surv_cutpoint(tcga_sur, time = "futime", event = "fustat",
                         variables = "Glycosylation" # 找这3个变量的最佳切点
)

summary(res.cut)

# 2. Plot cutpoint for DEPDC1
plot(res.cut, "Glycosylation", palette = "npg")
# 3. Categorize variables
res.cat <- surv_categorize(res.cut)
head(res.cat)




# 4. Fit survival curves and visualize
library("survival")
fit <- survfit(Surv(futime, fustat) ~Glycosylation, data = res.cat)
p1=ggsurvplot(fit, data = res.cat, risk.table = TRUE, conf.int = TRUE)
#ggsave(p1,file="01_2a_1.pdf")


#生存差异统计
length=length(levels(factor(res.cat$Glycosylation)))
diff=survdiff(Surv(futime, fustat) ~ Glycosylation, data = res.cat)
pValue=1-pchisq(diff$chisq, df=length-1)
if(pValue<0.001){
  pValue="p<0.001"
}else{
  pValue=paste0("p=",sprintf("%.03f",pValue))
}
fit <- survfit(Surv(futime, fustat) ~ Glycosylation, data = res.cat)
#print(surv_median(fit))

#绘制生存曲线
bioCol=c("#0066FF","#FF9900","#FF0000","#6E568C","#7CC767","#223D6C","#D20A13","#FFD121","#088247","#11AA4D")
bioCol=bioCol[1:length]
surPlot=ggsurvplot(fit, 
                   data=res.cat,
                   conf.int=F,
                   pval=pValue,
                   pval.size=6,
                   legend.title="Glycosylation",
                   legend.labs=levels(factor(res.cat[,"Glycosylation"])),
                   legend = c(0.8, 0.8),
                   font.legend=10,
                   xlab="Time(years)",
                   break.time.by = 1,
                   palette = bioCol,
                   surv.median.line = "hv",
                   risk.table=T,
                   cumevents=F,
                   risk.table.height=.25)
pdf(file="02A_survival.pdf",onefile = FALSE,width=7,height=5.5)
print(surPlot)
dev.off()

#####写出rtt

#################figure 2B WGCNA#######################
setwd("C:/Users/Zia20/OneDrive/01周志佳2023/02生信和基础文章/01前沿基因/28.WGCNA")

#引用包
library(limma)
library(WGCNA)

rtt=avereps(rtt)
rtt=rtt[apply(rtt,1,sd)>0,]     #删除波动小的基因
#datExpr0 = as.data.frame(t(rt))
datExpr0=avereps(rtt)
rtt=cbind(id=rownames(rtt),rtt)
write.table(rtt, file = "tcga.share.txt",sep="\t",row.names=F,quote=F)

cli=cbind(cli,gsva_cosre)
cli=cli[,-5]
write.table(cli, file = "clinical.txt",sep="\t",row.names=F,quote=F)
#########
###检查缺失值
gsg = goodSamplesGenes(datExpr0, verbose = 3)
if (!gsg$allOK){
  # Optionally, print the gene and sample names that were removed:
  if (sum(!gsg$goodGenes)>0)
    printFlush(paste("Removing genes:", paste(names(datExpr0)[!gsg$goodGenes], collapse = ", ")))
  if (sum(!gsg$goodSamples)>0)
    printFlush(paste("Removing samples:", paste(rownames(datExpr0)[!gsg$goodSamples], collapse = ", ")))
  # Remove the offending genes and samples from the data:
  datExpr0 = datExpr0[gsg$goodSamples, gsg$goodGenes]
}

###样品聚类
sampleTree = hclust(dist(datExpr0), method = "average")
pdf(file = "1_sample_cluster.pdf", width = 12, height = 9)
par(cex = 0.6)
par(mar = c(0,4,2,0))
plot(sampleTree, main = "Sample clustering to detect outliers", sub="", xlab="", cex.lab = 1.5, cex.axis = 1.5, cex.main = 2)
###剪切线
abline(h = 10000, col = "red")
dev.off()

###删除剪切线以下的样品
clust = cutreeStatic(sampleTree, cutHeight = 10000, minSize = 10)
table(clust)
keepSamples = (clust==1)
datExpr0 = datExpr0[keepSamples, ]

###power值散点图
enableWGCNAThreads()   #多线程工作
powers = c(1:20)       #幂指数范围1:20
sft = pickSoftThreshold(datExpr0, powerVector = powers, verbose = 5)
pdf(file="2_scale_independence.pdf",width=9,height=5)
par(mfrow = c(1,2))
cex1 = 0.9
###拟合指数与power值散点图
plot(sft$fitIndices[,1], -sign(sft$fitIndices[,3])*sft$fitIndices[,2],
     xlab="Soft Threshold (power)",ylab="Scale Free Topology Model Fit,signed R^2",type="n",
     main = paste("Scale independence"));
text(sft$fitIndices[,1], -sign(sft$fitIndices[,3])*sft$fitIndices[,2],
     labels=powers,cex=cex1,col="red");
abline(h=0.90,col="red") #可以修改
###平均连通性与power值散点图
plot(sft$fitIndices[,1], sft$fitIndices[,5],
     xlab="Soft Threshold (power)",ylab="Mean Connectivity", type="n",
     main = paste("Mean connectivity"))
text(sft$fitIndices[,1], sft$fitIndices[,5], labels=powers, cex=cex1,col="red")
dev.off()


###邻接矩阵转换
sft #查看最佳power值
softPower =sft$powerEstimate   #最佳power值
adjacency = adjacency(datExpr0, power = softPower)
softPower

###TOM矩阵
TOM = TOMsimilarity(adjacency)
dissTOM = 1-TOM

###基因聚类
geneTree = hclust(as.dist(dissTOM), method = "average");
pdf(file="3_gene_clustering.pdf",width=12,height=9)
plot(geneTree, xlab="", sub="", main = "Gene clustering on TOM-based dissimilarity",
     labels = FALSE, hang = 0.04)
dev.off()


###动态剪切模块识别
minModuleSize=30      #模块基因数目,每个模块最少包含多少个基因
dynamicMods = cutreeDynamic(dendro = geneTree, distM = dissTOM,
                            deepSplit = 2, pamRespectsDendro = FALSE,
                            minClusterSize = minModuleSize);
table(dynamicMods)
dynamicColors = labels2colors(dynamicMods)
table(dynamicColors)
pdf(file="4_Dynamic_Tree.pdf",width=8,height=6)
plotDendroAndColors(geneTree, dynamicColors, "Dynamic Tree Cut",
                    dendroLabels = FALSE, hang = 0.03,
                    addGuide = TRUE, guideHang = 0.05,
                    main = "Gene dendrogram and module colors")
dev.off()


###查找相似模块聚类
MEList = moduleEigengenes(datExpr0, colors = dynamicColors)
MEs = MEList$eigengenes
MEDiss = 1-cor(MEs);
METree = hclust(as.dist(MEDiss), method = "average")
pdf(file="5_Clustering_module.pdf",width=7,height=7)
plot(METree, main = "Clustering of module eigengenes",
     xlab = "", sub = "")
MEDissThres = 0.3  #剪切高度可修改
abline(h=MEDissThres, col = "red")
dev.off()


###相似模块合并
merge = mergeCloseModules(datExpr0, dynamicColors, cutHeight = MEDissThres, verbose = 3)
mergedColors = merge$colors
mergedMEs = merge$newMEs
pdf(file="6_merged_dynamic.pdf", width = 9, height = 6)
plotDendroAndColors(geneTree, mergedColors,"Dynamic Tree Cut",
                    dendroLabels = FALSE, hang = 0.03,
                    addGuide = TRUE, guideHang = 0.05,
                    main = "Gene dendrogram and module colors")
dev.off()
moduleColors = mergedColors
table(moduleColors)
colorOrder = c("grey", standardColors(50))
moduleLabels = match(moduleColors, colorOrder)-1
MEs = mergedMEs


###模块与临床性状的相关型热图

#cli=read.table(cliFile, header=T, sep="\t", check.names=F, row.names=1)
sameSample=intersect(row.names(cli), row.names(MEs))
MEs=MEs[sameSample,]
datTraits=cli[sameSample,]
nGenes = ncol(datExpr0)
nSamples = nrow(datExpr0)
moduleTraitCor = cor(MEs, datTraits, use = "p")
moduleTraitPvalue = corPvalueStudent(moduleTraitCor, nSamples)
pdf(file="7_Module_trait.pdf", width=6.5, height=5.2)
textMatrix = paste(signif(moduleTraitCor, 2), "\n(",
                   signif(moduleTraitPvalue, 1), ")", sep = "")
dim(textMatrix) = dim(moduleTraitCor)
par(mar = c(5, 10, 3, 3))
labeledHeatmap(Matrix = moduleTraitCor,
               xLabels = names(datTraits),
               yLabels = names(MEs),
               ySymbols = names(MEs),
               colorLabels = FALSE,
               colors = blueWhiteRed(50),
               textMatrix = textMatrix,
               setStdMargins = FALSE,
               cex.text = 0.5,
               zlim = c(-1,1),
               main = paste("Module-trait relationships"))
dev.off()

###基因所在的模块
probes = colnames(datExpr0)
geneInfo0 = data.frame(probes= probes,
                       moduleColor = moduleColors)
geneOrder =order(geneInfo0$moduleColor)
geneInfo = geneInfo0[geneOrder, ]
write.table(geneInfo, file = "allModules.txt",sep="\t",row.names=F,quote=F)


###输出每个模块的基因
for (mod in 1:nrow(table(moduleColors))){  
  modules = names(table(moduleColors))[mod]
  probes = colnames(datExpr0)
  inModule = (moduleColors == modules)
  modGenes = probes[inModule]
  write.table(modGenes, file =paste0("module_",modules,".txt"),sep="\t",row.names=F,col.names=F,quote=F)
}


################果子学生信#####################wgcna################
##########准备NMF分型#######################################
ep=rtt[intersect(cellMarker[[1]],rownames(rtt)),]
sample=intersect(colnames(ep),rownames(cli))
ep=cbind(cli,t(ep[,sample]))
ep=rbind(colnames(ep),ep)
setwd("C:/Users/Zia20/OneDrive/01周志佳2023/02生信和基础文章/01前沿基因/16.NMF")
write.table(ep, file="TCGA.expTime.txt", sep="\t", quote=F, col.names=F)
